Index: /code/trunk/src/core/CommandLine.h
===================================================================
--- /code/trunk/src/core/CommandLine.h	(revision 3299)
+++ /code/trunk/src/core/CommandLine.h	(revision 3300)
@@ -196,5 +196,5 @@
     inline void CommandLine::getValue<std::string>(const std::string& name, std::string* value)
     {
-        *value = (std::string)(getArgument(name)->getValue().getString());
+        *value = getArgument(name)->getValue().getString();
     }
 
Index: /code/trunk/src/core/Game.cc
===================================================================
--- /code/trunk/src/core/Game.cc	(revision 3299)
+++ /code/trunk/src/core/Game.cc	(revision 3300)
@@ -287,5 +287,5 @@
                 assert(it != this->statisticsTickTimes_.end());
                 int64_t lastTime = currentTime - this->configuration_->statisticsAvgLength_;
-                if ((int64_t)it->tickTime < lastTime)
+                if (static_cast<int64_t>(it->tickTime) < lastTime)
                 {
                     do
@@ -295,5 +295,5 @@
                         ++it;
                         assert(it != this->statisticsTickTimes_.end());
-                    } while ((int64_t)it->tickTime < lastTime);
+                    } while (static_cast<int64_t>(it->tickTime) < lastTime);
                     this->statisticsTickTimes_.erase(this->statisticsTickTimes_.begin(), it);
                 }
Index: /code/trunk/src/core/Shell.cc
===================================================================
--- /code/trunk/src/core/Shell.cc	(revision 3299)
+++ /code/trunk/src/core/Shell.cc	(revision 3300)
@@ -129,5 +129,5 @@
         this->inputBuffer_->registerListener(this, &Shell::backspace, '\b', true);
         this->inputBuffer_->registerListener(this, &Shell::deletechar, KeyCode::Delete);
-        this->inputBuffer_->registerListener(this, &Shell::exit, (char)27, true);
+        this->inputBuffer_->registerListener(this, &Shell::exit, static_cast<char>(27), true);
         this->inputBuffer_->registerListener(this, &Shell::cursor_right, KeyCode::Right);
         this->inputBuffer_->registerListener(this, &Shell::cursor_left, KeyCode::Left);
@@ -149,7 +149,7 @@
         Shell& instance = Shell::getInstance();
 
-        for (int i = instance.historyOffset_; i < (int)instance.commandHistory_.size(); ++i)
+        for (unsigned int i = instance.historyOffset_; i < instance.commandHistory_.size(); ++i)
             instance.addLine(instance.commandHistory_[i], -1);
-        for (int i =  0; i < (int)instance.historyOffset_; ++i)
+        for (unsigned int i =  0; i < instance.historyOffset_; ++i)
             instance.addLine(instance.commandHistory_[i], -1);
     }
Index: /code/trunk/src/core/TclThreadManager.cc
===================================================================
--- /code/trunk/src/core/TclThreadManager.cc	(revision 3299)
+++ /code/trunk/src/core/TclThreadManager.cc	(revision 3300)
@@ -577,9 +577,9 @@
                         this->debug("TclThread_query: " + command);
                         try
-                        {   output = (std::string)target->interpreter_->eval(command);   }
+                        {   output = static_cast<std::string>(target->interpreter_->eval(command));   }
                         catch (Tcl::tcl_error const &e)
-                        {   this->error("Tcl error: " + (std::string)e.what());   }
+                        {   this->error("Tcl error: " + static_cast<std::string>(e.what()));   }
                         catch (std::exception const &e)
-                        {   this->error("Error while executing Tcl: " + (std::string)e.what());   }
+                        {   this->error("Error while executing Tcl: " + static_cast<std::string>(e.what()));   }
                     }
                     else
Index: /code/trunk/src/orxonox/gamestates/GSDedicated.cc
===================================================================
--- /code/trunk/src/orxonox/gamestates/GSDedicated.cc	(revision 3299)
+++ /code/trunk/src/orxonox/gamestates/GSDedicated.cc	(revision 3300)
@@ -119,5 +119,5 @@
             msleep(static_cast<unsigned int>((NETWORK_PERIOD - timeSinceLastUpdate_)*1000));
             msleep(static_cast<unsigned int>(NETWORK_PERIOD*1000)); // NOTE: this is to throttle the non-network framerate
-//            COUT(0) << "sleeping for " << (int)((NETWORK_PERIOD - timeSinceLastUpdate_) * 1000 * 1000) << " usec" << endl;
+//            COUT(0) << "sleeping for " << static_cast<int>((NETWORK_PERIOD - timeSinceLastUpdate_) * 1000 * 1000) << " usec" << endl;
         }
         processQueue();
Index: /code/trunk/src/orxonox/interfaces/RadarViewable.cc
===================================================================
--- /code/trunk/src/orxonox/interfaces/RadarViewable.cc	(revision 3299)
+++ /code/trunk/src/orxonox/interfaces/RadarViewable.cc	(revision 3300)
@@ -122,5 +122,5 @@
         {
             this->MapNode_->setPosition( this->getRVWorldPosition() );
-            this->MapNode_->translate( this->getRVOrientedVelocity(), (Ogre::Node::TransformSpace)3 );
+            this->MapNode_->translate( this->getRVOrientedVelocity(), static_cast<Ogre::Node::TransformSpace>(3) );
             this->MapNode_->setOrientation( this->getWorldEntity()->getOrientation() );
 //Vector3 v = this->getRVWorldPosition();
Index: /code/trunk/src/orxonox/objects/gametypes/TeamDeathmatch.cc
===================================================================
--- /code/trunk/src/orxonox/objects/gametypes/TeamDeathmatch.cc	(revision 3299)
+++ /code/trunk/src/orxonox/objects/gametypes/TeamDeathmatch.cc	(revision 3300)
@@ -71,5 +71,5 @@
 
         for (std::map<PlayerInfo*, int>::iterator it = this->teamnumbers_.begin(); it != this->teamnumbers_.end(); ++it)
-            if (it->second < (int)this->teams_ && it->second >= 0)
+            if (it->second < static_cast<int>(this->teams_) && it->second >= 0)
                 playersperteam[it->second]++;
 
@@ -127,5 +127,5 @@
             {
                 TeamSpawnPoint* tsp = dynamic_cast<TeamSpawnPoint*>(*it);
-                if (tsp && (int)tsp->getTeamNumber() != desiredTeamNr)
+                if (tsp && static_cast<int>(tsp->getTeamNumber()) != desiredTeamNr)
                 {
                     teamSpawnPoints.erase(it++);
@@ -160,5 +160,5 @@
         // Set the team colour
         std::map<PlayerInfo*, int>::const_iterator it_player = this->teamnumbers_.find(player);
-        if (it_player != this->teamnumbers_.end() && it_player->second >= 0 && it_player->second < (int)this->teamcolours_.size())
+        if (it_player != this->teamnumbers_.end() && it_player->second >= 0 && it_player->second < static_cast<int>(this->teamcolours_.size()))
         {
             if (pawn)
Index: /code/trunk/src/orxonox/objects/gametypes/UnderAttack.cc
===================================================================
--- /code/trunk/src/orxonox/objects/gametypes/UnderAttack.cc	(revision 3299)
+++ /code/trunk/src/orxonox/objects/gametypes/UnderAttack.cc	(revision 3300)
@@ -51,5 +51,5 @@
 
         this->setConfigValues();
-        this->timesequence_ = (int) this->gameTime_;
+        this->timesequence_ = static_cast<this->gameTime_);
     }
 
Index: /code/trunk/src/orxonox/objects/infos/Bot.cc
===================================================================
--- /code/trunk/src/orxonox/objects/infos/Bot.cc	(revision 3299)
+++ /code/trunk/src/orxonox/objects/infos/Bot.cc	(revision 3300)
@@ -52,5 +52,5 @@
         this->setConfigValues();
 
-        this->setName(this->names_[(size_t)(rnd() * this->names_.size())]);
+        this->setName(this->names_[static_cast<size_t>(rnd() * this->names_.size())]);
 
         if (this->getGametype())
Index: /code/trunk/src/orxonox/objects/pickup/PickupCollection.cc
===================================================================
--- /code/trunk/src/orxonox/objects/pickup/PickupCollection.cc	(revision 3299)
+++ /code/trunk/src/orxonox/objects/pickup/PickupCollection.cc	(revision 3300)
@@ -86,5 +86,5 @@
     bool PickupCollection::checkSlot(BaseItem* item)
     {
-        return ((int)this->items_.count(item->getPickupIdentifier()) < item->getMaxCarryAmount());
+        return (static_cast<int>(this->items_.count(item->getPickupIdentifier())) < item->getMaxCarryAmount());
     }
     /**
Index: /code/trunk/src/orxonox/objects/worldentities/ParticleEmitter.h
===================================================================
--- /code/trunk/src/orxonox/objects/worldentities/ParticleEmitter.h	(revision 3299)
+++ /code/trunk/src/orxonox/objects/worldentities/ParticleEmitter.h	(revision 3300)
@@ -64,5 +64,5 @@
         protected:
             inline void setLODxml(unsigned int level)
-                { this->LOD_ = (LODParticle::Value)level; this->LODchanged(); }
+                { this->LOD_ = static_cast<LODParticle::Value>(level); this->LODchanged(); }
             inline unsigned int getLODxml() const
                 { return (unsigned int)this->LOD_; }
Index: /code/trunk/src/orxonox/objects/worldentities/pawns/Pawn.cc
===================================================================
--- /code/trunk/src/orxonox/objects/worldentities/pawns/Pawn.cc	(revision 3299)
+++ /code/trunk/src/orxonox/objects/worldentities/pawns/Pawn.cc	(revision 3300)
@@ -281,5 +281,5 @@
         else
         {
-            callMemberNetworkFunction(Pawn, doFire, this->getObjectID(), 0, ((uint8_t)firemode));
+            callMemberNetworkFunction(Pawn, doFire, this->getObjectID(), 0, firemode);
             if (this->weaponSystem_)
                 this->weaponSystem_->fire(firemode);
Index: /code/trunk/src/orxonox/overlays/GUIOverlay.cc
===================================================================
--- /code/trunk/src/orxonox/overlays/GUIOverlay.cc	(revision 3299)
+++ /code/trunk/src/orxonox/overlays/GUIOverlay.cc	(revision 3300)
@@ -67,5 +67,5 @@
             std::string str;
             std::stringstream out;
-            out << (long)this;
+            out << static_cast<long>(this);
             str = out.str();
             GUIManager::getInstance().executeCode("showCursor()");
Index: /code/trunk/src/orxonox/overlays/OrxonoxOverlay.cc
===================================================================
--- /code/trunk/src/orxonox/overlays/OrxonoxOverlay.cc	(revision 3299)
+++ /code/trunk/src/orxonox/overlays/OrxonoxOverlay.cc	(revision 3300)
@@ -215,5 +215,5 @@
             if (angle < 0.0)
                 angle = -angle;
-            angle -= 180.0f * (int)(angle / 180.0);
+            angle -= 180.0f * static_caste<int>(angle / 180.0);
 
             // take the reverse if angle is about 90 degrees
@@ -277,5 +277,5 @@
         if (angle < 0.0)
             angle = -angle;
-        angle -= Ogre::Math::PI * (int)(angle / (Ogre::Math::PI));
+        angle -= Ogre::Math::PI * static_cast<int>(angle / (Ogre::Math::PI));
         if (angle > Ogre::Math::PI * 0.5)
             angle = Ogre::Math::PI - angle;
Index: /code/trunk/src/orxonox/overlays/console/InGameConsole.cc
===================================================================
--- /code/trunk/src/orxonox/overlays/console/InGameConsole.cc	(revision 3299)
+++ /code/trunk/src/orxonox/overlays/console/InGameConsole.cc	(revision 3300)
@@ -332,5 +332,5 @@
 
         this->consoleOverlayCursor_->setCaption(std::string(pos,' ') + cursorSymbol_);
-        this->consoleOverlayCursor_->setTop((int) this->windowH_ * this->relativeHeight - 24);
+        this->consoleOverlayCursor_->setTop(static_cast<int>(this->windowH_ * this->relativeHeight) - 24);
     }
 
@@ -416,15 +416,15 @@
         this->windowW_ = newWidth;
         this->windowH_ = newHeight;
-        this->consoleOverlayBorder_->setWidth((int) this->windowW_* this->relativeWidth);
-        this->consoleOverlayBorder_->setHeight((int) this->windowH_ * this->relativeHeight);
-        this->consoleOverlayNoise_->setWidth((int) this->windowW_ * this->relativeWidth - 10);
-        this->consoleOverlayNoise_->setHeight((int) this->windowH_ * this->relativeHeight - 5);
+        this->consoleOverlayBorder_->setWidth(static_cast<int>(this->windowW_* this->relativeWidth));
+        this->consoleOverlayBorder_->setHeight(static_cast<int>(this->windowH_ * this->relativeHeight));
+        this->consoleOverlayNoise_->setWidth(static_cast<int>(this->windowW_ * this->relativeWidth) - 10);
+        this->consoleOverlayNoise_->setHeight(static_cast<int>(this->windowH_ * this->relativeHeight) - 5);
         this->consoleOverlayNoise_->setTiling(consoleOverlayNoise_->getWidth() / (50.0f * this->noiseSize_), consoleOverlayNoise_->getHeight() / (50.0f * this->noiseSize_));
 
         // now adjust the text lines...
-        this->desiredTextWidth_ = (int) (this->windowW_ * this->relativeWidth) - 12;
+        this->desiredTextWidth_ = static_cast<int>(this->windowW_ * this->relativeWidth) - 12;
 
         if (LINES > 0)
-            this->maxCharsPerLine_ = std::max((unsigned int)10, (unsigned int) ((float)this->desiredTextWidth_ / CHAR_WIDTH));
+            this->maxCharsPerLine_ = std::max(10U, static_cast<unsigned int>(static_cast<float>(this->desiredTextWidth_) / CHAR_WIDTH));
         else
             this->maxCharsPerLine_ = 10;
@@ -433,5 +433,5 @@
         {
             this->consoleOverlayTextAreas_[i]->setWidth(this->desiredTextWidth_);
-            this->consoleOverlayTextAreas_[i]->setTop((int) this->windowH_ * this->relativeHeight - 24 - 14*i);
+            this->consoleOverlayTextAreas_[i]->setTop(static_cast<int>(this->windowH_ * this->relativeHeight) - 24 - 14*i);
         }
 
Index: /code/trunk/src/orxonox/overlays/hud/GametypeStatus.cc
===================================================================
--- /code/trunk/src/orxonox/overlays/hud/GametypeStatus.cc	(revision 3299)
+++ /code/trunk/src/orxonox/overlays/hud/GametypeStatus.cc	(revision 3300)
@@ -70,5 +70,5 @@
             {
                 if (gtinfo->isStartCountdownRunning())
-                    this->setCaption(multi_cast<std::string>((int)ceil(gtinfo->getStartCountdown())));
+                    this->setCaption(multi_cast<std::string>(static_cast<int>(ceil(gtinfo->getStartCountdown()))));
                 else if (ce->isA(Class(Spectator)))
                     this->setCaption("Press [Fire] to respawn");
Index: /code/trunk/src/orxonox/overlays/hud/HUDBar.cc
===================================================================
--- /code/trunk/src/orxonox/overlays/hud/HUDBar.cc	(revision 3299)
+++ /code/trunk/src/orxonox/overlays/hud/HUDBar.cc	(revision 3300)
@@ -73,5 +73,5 @@
         // create new material
         std::string materialname = "barmaterial" + multi_cast<std::string>(materialcount_s++);
-        Ogre::MaterialPtr material = (Ogre::MaterialPtr)Ogre::MaterialManager::getSingleton().create(materialname, "General");
+        Ogre::MaterialPtr material = static_cast<Ogre::MaterialPtr>(Ogre::MaterialManager::getSingleton().create(materialname, "General"));
         material->getTechnique(0)->getPass(0)->setSceneBlending(Ogre::SBT_TRANSPARENT_ALPHA);
         this->textureUnitState_ = material->getTechnique(0)->getPass(0)->createTextureUnitState();
Index: /code/trunk/src/orxonox/overlays/hud/HUDHealthBar.cc
===================================================================
--- /code/trunk/src/orxonox/overlays/hud/HUDHealthBar.cc	(revision 3299)
+++ /code/trunk/src/orxonox/overlays/hud/HUDHealthBar.cc	(revision 3300)
@@ -83,5 +83,5 @@
         {
             this->setValue(this->owner_->getHealth() / this->owner_->getInitialHealth());
-            this->textoverlay_->setCaption(multi_cast<std::string>((int)this->owner_->getHealth()));
+            this->textoverlay_->setCaption(multi_cast<std::string>(static_cast<int>(this->owner_->getHealth())));
         }
 
Index: /code/trunk/src/orxonox/overlays/hud/HUDTimer.cc
===================================================================
--- /code/trunk/src/orxonox/overlays/hud/HUDTimer.cc	(revision 3299)
+++ /code/trunk/src/orxonox/overlays/hud/HUDTimer.cc	(revision 3300)
@@ -59,5 +59,5 @@
             if (gametype->getTimerIsActive())
             {
-                this->setCaption(multi_cast<std::string>((int)gametype->getTime() + 1));
+                this->setCaption(multi_cast<std::string>(static_cast<int>(gametype->getTime()) + 1));
             }
         }
Index: /code/trunk/src/orxonox/overlays/map/Map.cc
===================================================================
--- /code/trunk/src/orxonox/overlays/map/Map.cc	(revision 3299)
+++ /code/trunk/src/orxonox/overlays/map/Map.cc	(revision 3300)
@@ -332,5 +332,5 @@
                 //this->CamNodeHelper_->attachObject(this->Cam_);
                     this->Cam_->setPosition(0, 0, DISTANCE);
-                    this->Cam_->pitch( (Degree)PITCH );
+                    this->Cam_->pitch( static_cast<Degree>(PITCH) );
                     this->Cam_->lookAt(Vector3(0,0,0));
                 //this->Cam_->setAutoTracking(true, this->playerShipNode_);
@@ -425,10 +425,10 @@
 
 /*
-        singletonMap_s->CamNode_->setOrientation(singletonMap_s->CamNode_->getOrientation() * Quaternion( (Degree)(-value.y * singletonMap_s->mouseLookSpeed_) , singletonMap_s->playerShipNode_->getLocalAxes().GetColumn(1) ));
+        singletonMap_s->CamNode_->setOrientation(singletonMap_s->CamNode_->getOrientation() * Quaternion( static_cast<Degree>(-value.y * singletonMap_s->mouseLookSpeed_) , singletonMap_s->playerShipNode_->getLocalAxes().GetColumn(1) ));
 
         Map::singletonMap_s->CamNodeHelper_->setDirection(Vector3::UNIT_Y, Ogre::Node::TS_PARENT, Vector3::UNIT_Y);
         Map::singletonMap_s->CamNodeHelper_->lookAt(Vector3(0,0,0), Ogre::Node::TS_PARENT);
 */
-        singletonMap_s->CamNode_->yaw( (Degree)(-value.y * singletonMap_s->mouseLookSpeed_), Ogre::Node::TS_PARENT);
+        singletonMap_s->CamNode_->yaw( static_cast<Degree>(-value.y * singletonMap_s->mouseLookSpeed_), Ogre::Node::TS_PARENT);
     }
 
@@ -437,11 +437,11 @@
         if(!( Map::singletonMap_s && Map::singletonMap_s->CamNode_ ))
             return;
-            //singletonMap_s->Cam_->setOrientation(singletonMap_s->Cam_->getOrientation() * Quaternion( (Degree)(-value.y * singletonMap_s->mouseLookSpeed_) , Vector3::UNIT_X));
-/*        singletonMap_s->CamNode_->setOrientation(singletonMap_s->CamNode_->getOrientation() * Quaternion( (Degree)(-value.y * singletonMap_s->mouseLookSpeed_) , singletonMap_s->playerShipNode_->getLocalAxes().GetColumn(0) ));
+            //singletonMap_s->Cam_->setOrientation(singletonMap_s->Cam_->getOrientation() * Quaternion( static_cast<Degree>(-value.y * singletonMap_s->mouseLookSpeed_) , Vector3::UNIT_X));
+/*        singletonMap_s->CamNode_->setOrientation(singletonMap_s->CamNode_->getOrientation() * Quaternion( static_cast<Degree>(-value.y * singletonMap_s->mouseLookSpeed_) , singletonMap_s->playerShipNode_->getLocalAxes().GetColumn(0) ));
 
         Map::singletonMap_s->CamNodeHelper_->setDirection(Vector3::UNIT_Y, Ogre::Node::TS_PARENT, Vector3::UNIT_Y);
         Map::singletonMap_s->CamNodeHelper_->lookAt(Vector3(0,0,0), Ogre::Node::TS_PARENT);
 */
-        singletonMap_s->CamNode_->pitch( (Degree)(value.y * singletonMap_s->mouseLookSpeed_), Ogre::Node::TS_LOCAL);
+        singletonMap_s->CamNode_->pitch( static_cast<Degree>(value.y * singletonMap_s->mouseLookSpeed_), Ogre::Node::TS_LOCAL);
 
     }
Index: /code/trunk/src/orxonox/tools/TextureGenerator.cc
===================================================================
--- /code/trunk/src/orxonox/tools/TextureGenerator.cc	(revision 3299)
+++ /code/trunk/src/orxonox/tools/TextureGenerator.cc	(revision 3300)
@@ -73,5 +73,5 @@
         {
             std::string materialName = textureName + "_Material_" + multi_cast<std::string>(materialCount_s++);
-            Ogre::MaterialPtr material = (Ogre::MaterialPtr)Ogre::MaterialManager::getSingleton().create(materialName, "General");
+            Ogre::MaterialPtr material = static_cast<Ogre::MaterialPtr>(Ogre::MaterialManager::getSingleton().create(materialName, "General"));
             material->getTechnique(0)->getPass(0)->setSceneBlending(Ogre::SBT_TRANSPARENT_ALPHA);
             Ogre::TextureUnitState* textureUnitState = material->getTechnique(0)->getPass(0)->createTextureUnitState();
Index: /code/trunk/src/orxonox/tools/Timer.h
===================================================================
--- /code/trunk/src/orxonox/tools/Timer.h	(revision 3299)
+++ /code/trunk/src/orxonox/tools/Timer.h	(revision 3300)
@@ -100,5 +100,5 @@
             /** @brief Returns the remaining time until the Timer calls the function. @return The remaining time */
             inline float getRemainingTime() const
-                { return (float)this->time_ / 1000000.0f; }
+                { return static_cast<float>(this->time_ / 1000000.0f); }
             /** @brief Gives the Timer some extra time. @param time The amount of extra time in seconds */
             inline void addTime(float time)
Index: /code/trunk/src/util/Math.h
===================================================================
--- /code/trunk/src/util/Math.h	(revision 3299)
+++ /code/trunk/src/util/Math.h	(revision 3300)
@@ -122,5 +122,5 @@
     inline int round(T x)
     {
-        return (int)(x + 0.5);
+        return static_cast<int>(x + 0.5);
     }
 
Index: /code/trunk/src/util/StringUtils.cc
===================================================================
--- /code/trunk/src/util/StringUtils.cc	(revision 3299)
+++ /code/trunk/src/util/StringUtils.cc	(revision 3300)
@@ -82,5 +82,5 @@
     {
         size_t pos1 = 0;
-        int pos2 = (int)(str.size() - 1);
+        int pos2 = static_cast<int>(str.size() - 1);
         for (; pos1 < str.size() && (str[pos1] == ' ' || str[pos1] == '\t' || str[pos1] == '\n'); pos1++);
         for (; pos2 > 0         && (str[pos2] == ' ' || str[pos2] == '\t' || str[pos2] == '\n'); pos2--);
@@ -352,5 +352,5 @@
         for (size_t i = 0; i < str->size(); ++i)
         {
-            (*str)[i] = (char)tolower((*str)[i]);
+            (*str)[i] = static_cast<char>(tolower((*str)[i]));
         }
     }
@@ -376,5 +376,5 @@
         for (size_t i = 0; i < str->size(); ++i)
         {
-            (*str)[i] = (char)toupper((*str)[i]);
+            (*str)[i] = static_cast<char>(toupper((*str)[i]));
         }
     }