Index: code/trunk/src/orxonox/gamestates/GSDedicated.cc
===================================================================
--- code/trunk/src/orxonox/gamestates/GSDedicated.cc	(revision 3300)
+++ code/trunk/src/orxonox/gamestates/GSDedicated.cc	(revision 3301)
@@ -193,5 +193,5 @@
 //                             boost::recursive_mutex::scoped_lock(this->inputLineMutex_);
                             std::cout << endl << CommandExecutor::hint( std::string((const char*)this->commandLine_,inputIterator_) ) << endl;
-                            strncpy((char*)this->commandLine_, CommandExecutor::complete( std::string((const char*)this->commandLine_,inputIterator_) ).c_str(), MAX_COMMAND_LENGTH);
+                            strncpy(reinterpret_cast<char*>(this->commandLine_), CommandExecutor::complete( std::string(reinterpret_cast<char*>(this->commandLine_),inputIterator_) ).c_str(), MAX_COMMAND_LENGTH);
                             inputIterator_ = strlen((const char*)this->commandLine_);
                             break;
@@ -275,5 +275,5 @@
     void GSDedicated::insertCharacter( unsigned int position, char c )
     {
-//         std::cout << endl << (unsigned int)c << endl;
+//         std::cout << endl << static_cast<unsigned int>(c) << endl;
         // check that we do not exceed MAX_COMMAND_LENGTH
         if( inputIterator_+1 < MAX_COMMAND_LENGTH )
Index: code/trunk/src/orxonox/objects/Scene.cc
===================================================================
--- code/trunk/src/orxonox/objects/Scene.cc	(revision 3300)
+++ code/trunk/src/orxonox/objects/Scene.cc	(revision 3301)
@@ -325,7 +325,7 @@
     {
         // get the WorldEntity pointers
-        WorldEntity* object0 = (WorldEntity*)colObj0->getUserPointer();
+        WorldEntity* object0 = static_cast<WorldEntity*>(colObj0->getUserPointer());
         assert(dynamic_cast<WorldEntity*>(object0));
-        WorldEntity* object1 = (WorldEntity*)colObj1->getUserPointer();
+        WorldEntity* object1 = static_cast<WorldEntity*>(colObj1->getUserPointer());
         assert(dynamic_cast<WorldEntity*>(object1));
 
Index: code/trunk/src/orxonox/objects/collisionshapes/CollisionShape.h
===================================================================
--- code/trunk/src/orxonox/objects/collisionshapes/CollisionShape.h	(revision 3300)
+++ code/trunk/src/orxonox/objects/collisionshapes/CollisionShape.h	(revision 3301)
@@ -63,5 +63,5 @@
             virtual void setScale3D(const Vector3& scale);
             virtual void setScale(float scale);
-            inline const Vector3& getScale3D(void) const
+            inline const Vector3& getScale3D() const
                 { return this->scale_; }
 
Index: code/trunk/src/orxonox/objects/controllers/WaypointPatrolController.cc
===================================================================
--- code/trunk/src/orxonox/objects/controllers/WaypointPatrolController.cc	(revision 3300)
+++ code/trunk/src/orxonox/objects/controllers/WaypointPatrolController.cc	(revision 3301)
@@ -85,5 +85,5 @@
 
         Vector3 myposition = this->getControllableEntity()->getPosition();
-        float shortestsqdistance = (unsigned int)-1;
+        float shortestsqdistance = static_cast<unsigned int>(-1);
 
         for (ObjectList<Pawn>::iterator it = ObjectList<Pawn>::begin(); it != ObjectList<Pawn>::end(); ++it)
Index: code/trunk/src/orxonox/objects/gametypes/TeamDeathmatch.cc
===================================================================
--- code/trunk/src/orxonox/objects/gametypes/TeamDeathmatch.cc	(revision 3300)
+++ code/trunk/src/orxonox/objects/gametypes/TeamDeathmatch.cc	(revision 3301)
@@ -74,5 +74,5 @@
                 playersperteam[it->second]++;
 
-        unsigned int minplayers = (unsigned int)-1;
+        unsigned int minplayers = static_cast<unsigned int>(-1);
         size_t minplayersteam = 0;
         for (size_t i = 0; i < this->teams_; ++i)
Index: code/trunk/src/orxonox/objects/gametypes/UnderAttack.cc
===================================================================
--- code/trunk/src/orxonox/objects/gametypes/UnderAttack.cc	(revision 3300)
+++ code/trunk/src/orxonox/objects/gametypes/UnderAttack.cc	(revision 3301)
@@ -51,5 +51,5 @@
 
         this->setConfigValues();
-        this->timesequence_ = static_cast<this->gameTime_);
+        this->timesequence_ = static_cast<int>(this->gameTime_);
     }
 
Index: code/trunk/src/orxonox/objects/weaponsystem/Munition.cc
===================================================================
--- code/trunk/src/orxonox/objects/weaponsystem/Munition.cc	(revision 3300)
+++ code/trunk/src/orxonox/objects/weaponsystem/Munition.cc	(revision 3301)
@@ -354,5 +354,5 @@
             return false;
 
-        if (amount <= (unsigned int)needed_magazines)
+        if (amount <= static_cast<unsigned int>(needed_magazines))
         {
             // We need more magazines than we get, so just add them
Index: code/trunk/src/orxonox/objects/weaponsystem/WeaponSystem.h
===================================================================
--- code/trunk/src/orxonox/objects/weaponsystem/WeaponSystem.h	(revision 3300)
+++ code/trunk/src/orxonox/objects/weaponsystem/WeaponSystem.h	(revision 3301)
@@ -84,8 +84,8 @@
 
             static const unsigned int MAX_FIRE_MODES = 8;
-            static const unsigned int FIRE_MODE_UNASSIGNED = (unsigned int)-1;
+            static const unsigned int FIRE_MODE_UNASSIGNED = static_cast<unsigned int>(-1);
 
             static const unsigned int MAX_WEAPON_MODES = 8;
-            static const unsigned int WEAPON_MODE_UNASSIGNED = (unsigned int)-1;
+            static const unsigned int WEAPON_MODE_UNASSIGNED = static_cast<unsigned int>(-1);
 
         private:
Index: code/trunk/src/orxonox/objects/worldentities/ParticleEmitter.h
===================================================================
--- code/trunk/src/orxonox/objects/worldentities/ParticleEmitter.h	(revision 3300)
+++ code/trunk/src/orxonox/objects/worldentities/ParticleEmitter.h	(revision 3301)
@@ -66,5 +66,5 @@
                 { this->LOD_ = static_cast<LODParticle::Value>(level); this->LODchanged(); }
             inline unsigned int getLODxml() const
-                { return (unsigned int)this->LOD_; }
+                { return static_cast<unsigned int>(this->LOD_); }
 
             void sourceChanged();
Index: code/trunk/src/orxonox/objects/worldentities/WorldEntity.h
===================================================================
--- code/trunk/src/orxonox/objects/worldentities/WorldEntity.h	(revision 3300)
+++ code/trunk/src/orxonox/objects/worldentities/WorldEntity.h	(revision 3301)
@@ -148,5 +148,5 @@
             inline void setScale3D(float x, float y, float z)
                 { this->setScale3D(Vector3(x, y, z)); }
-            const Vector3& getScale3D(void) const;
+            const Vector3& getScale3D() const;
             const Vector3& getWorldScale3D() const;
 
@@ -457,5 +457,5 @@
     inline const Quaternion& WorldEntity::getOrientation() const
         { return this->node_->getOrientation(); }
-    inline const Vector3& WorldEntity::getScale3D(void) const
+    inline const Vector3& WorldEntity::getScale3D() const
         { return this->node_->getScale(); }
 #endif
Index: code/trunk/src/orxonox/overlays/GUIOverlay.cc
===================================================================
--- code/trunk/src/orxonox/overlays/GUIOverlay.cc	(revision 3300)
+++ code/trunk/src/orxonox/overlays/GUIOverlay.cc	(revision 3301)
@@ -67,5 +67,5 @@
             std::string str;
             std::stringstream out;
-            out << static_cast<long>(this);
+            out << reinterpret_cast<long>(this);
             str = out.str();
             GUIManager::getInstance().executeCode("showCursor()");
Index: code/trunk/src/orxonox/overlays/OrxonoxOverlay.cc
===================================================================
--- code/trunk/src/orxonox/overlays/OrxonoxOverlay.cc	(revision 3300)
+++ code/trunk/src/orxonox/overlays/OrxonoxOverlay.cc	(revision 3301)
@@ -82,5 +82,5 @@
         // Get aspect ratio from the render window. Later on, we get informed automatically
         Ogre::RenderWindow* defaultWindow = GraphicsManager::getInstance().getRenderWindow();
-        this->windowAspectRatio_ = (float)defaultWindow->getWidth() / defaultWindow->getHeight();
+        this->windowAspectRatio_ = static_cast<float>(defaultWindow->getWidth()) / defaultWindow->getHeight();
         this->sizeCorrectionChanged();
 
@@ -183,5 +183,5 @@
     void OrxonoxOverlay::windowResized(unsigned int newWidth, unsigned int newHeight)
     {
-        this->windowAspectRatio_ = newWidth/(float)newHeight;
+        this->windowAspectRatio_ = static_cast<float>(newWidth) / newHeight;
         this->sizeCorrectionChanged();
     }
@@ -215,5 +215,5 @@
             if (angle < 0.0)
                 angle = -angle;
-            angle -= 180.0f * static_caste<int>(angle / 180.0);
+            angle -= 180.0f * static_cast<int>(angle / 180.0);
 
             // take the reverse if angle is about 90 degrees
Index: code/trunk/src/orxonox/overlays/console/InGameConsole.cc
===================================================================
--- code/trunk/src/orxonox/overlays/console/InGameConsole.cc	(revision 3300)
+++ code/trunk/src/orxonox/overlays/console/InGameConsole.cc	(revision 3301)
@@ -93,5 +93,5 @@
         @brief Destructor: Destroys the TextAreas.
     */
-    InGameConsole::~InGameConsole(void)
+    InGameConsole::~InGameConsole()
     {
         this->deactivate();
Index: code/trunk/src/orxonox/overlays/hud/HUDNavigation.cc
===================================================================
--- code/trunk/src/orxonox/overlays/hud/HUDNavigation.cc	(revision 3300)
+++ code/trunk/src/orxonox/overlays/hud/HUDNavigation.cc	(revision 3301)
@@ -141,5 +141,5 @@
 
         // set text
-        int dist = (int) getDist2Focus();
+        int dist = static_cast<int>(getDist2Focus());
         navText_->setCaption(multi_cast<std::string>(dist));
         float textLength = multi_cast<std::string>(dist).size() * navText_->getCharHeight() * 0.3;
Index: code/trunk/src/orxonox/overlays/notifications/NotificationOverlay.cc
===================================================================
--- code/trunk/src/orxonox/overlays/notifications/NotificationOverlay.cc	(revision 3300)
+++ code/trunk/src/orxonox/overlays/notifications/NotificationOverlay.cc	(revision 3301)
@@ -129,5 +129,5 @@
     std::string NotificationOverlay::clipMessage(const std::string & message)
     {
-        if(message.length() <= (unsigned int)this->queue_->getNotificationLength()) //!< If the message is not too long.
+        if(message.length() <= static_cast<unsigned int>(this->queue_->getNotificationLength())) //!< If the message is not too long.
             return message;
         return message.substr(0, this->queue_->getNotificationLength());
Index: code/trunk/src/orxonox/overlays/notifications/NotificationQueue.cc
===================================================================
--- code/trunk/src/orxonox/overlays/notifications/NotificationQueue.cc	(revision 3300)
+++ code/trunk/src/orxonox/overlays/notifications/NotificationQueue.cc	(revision 3301)
@@ -398,5 +398,5 @@
         timeString.erase(timeString.length()-1);
         std::ostringstream stream;
-        stream << (unsigned long)notification;
+        stream << reinterpret_cast<unsigned long>(notification);
         std::string addressString = stream.str() ;
         container->name = "NotificationOverlay(" + timeString + ")&" + addressString;
Index: code/trunk/src/orxonox/tools/ParticleInterface.cc
===================================================================
--- code/trunk/src/orxonox/tools/ParticleInterface.cc	(revision 3300)
+++ code/trunk/src/orxonox/tools/ParticleInterface.cc	(revision 3301)
@@ -79,5 +79,5 @@
         }
 
-        this->setDetailLevel((unsigned int)detaillevel);
+        this->setDetailLevel(static_cast<unsigned int>(detaillevel));
     }
 
@@ -185,5 +185,5 @@
     void ParticleInterface::detailLevelChanged(unsigned int newlevel)
     {
-        if (newlevel >= (unsigned int)this->detaillevel_)
+        if (newlevel >= static_cast<unsigned int>(this->detaillevel_))
             this->bAllowedByLOD_ = true;
         else
Index: code/trunk/src/orxonox/tools/Shader.cc
===================================================================
--- code/trunk/src/orxonox/tools/Shader.cc	(revision 3300)
+++ code/trunk/src/orxonox/tools/Shader.cc	(revision 3301)
@@ -165,7 +165,7 @@
             if (pointer->first)
             {
-                if ((*((float*)pointer->second)) != value)
-                {
-                    (*((float*)pointer->second)) = value;
+                if ((*static_cast<float*>(pointer->second)) != value)
+                {
+                    (*static_cast<float*>(pointer->second)) = value;
                     return true;
                 }
@@ -173,7 +173,7 @@
             else
             {
-                if ((*((int*)pointer->second)) != (int)value)
-                {
-                    (*((int*)pointer->second)) = (int)value;
+                if ((*static_cast<int*>(pointer->second)) != static_cast<int>(value))
+                {
+                    (*static_cast<int*>(pointer->second)) = static_cast<int>(value);
                     return true;
                 }
@@ -190,7 +190,7 @@
             if (pointer->first)
             {
-                if ((*((float*)pointer->second)) != (float)value)
-                {
-                    (*((float*)pointer->second)) = (float)value;
+                if ((*static_cast<float*>(pointer->second)) != static_cast<float>(value))
+                {
+                    (*static_cast<float*>(pointer->second)) = static_cast<float>(value);
                     return true;
                 }
@@ -198,7 +198,7 @@
             else
             {
-                if ((*((int*)pointer->second)) != value)
-                {
-                    (*((int*)pointer->second)) = value;
+                if ((*static_cast<int*>(pointer->second)) != value)
+                {
+                    (*static_cast<int*>(pointer->second)) = value;
                     return true;
                 }
@@ -214,7 +214,7 @@
         {
             if (pointer->first)
-                return (*((float*)pointer->second));
+                return (*static_cast<float*>(pointer->second));
             else
-                return static_cast<float>(*((int*)pointer->second));
+                return static_cast<float>(*static_cast<int*>(pointer->second));
         }
         else
@@ -309,6 +309,6 @@
                         {
                             void* temp = (definition_iterator->second.isFloat())
-                                            ? (void*)parameter_pointer->getFloatPointer(definition_iterator->second.physicalIndex)
-                                            : (void*)parameter_pointer->getIntPointer(definition_iterator->second.physicalIndex);
+                                            ? static_cast<void*>(parameter_pointer->getFloatPointer(definition_iterator->second.physicalIndex))
+                                            : static_cast<void*>(parameter_pointer->getIntPointer(definition_iterator->second.physicalIndex));
                             ParameterPointer parameter_pointer = ParameterPointer(definition_iterator->second.isFloat(), temp);
 
Index: code/trunk/src/orxonox/tools/Timer.cc
===================================================================
--- code/trunk/src/orxonox/tools/Timer.cc	(revision 3300)
+++ code/trunk/src/orxonox/tools/Timer.cc	(revision 3301)
@@ -136,5 +136,5 @@
         {
             // If active: Decrease the timer by the duration of the last frame
-            this->time_ -= (long long)(time.getDeltaTimeMicroseconds() * this->getTimeFactor());
+            this->time_ -= static_cast<long long>(time.getDeltaTimeMicroseconds() * this->getTimeFactor());
 
             if (this->time_ <= 0)
Index: code/trunk/src/orxonox/tools/Timer.h
===================================================================
--- code/trunk/src/orxonox/tools/Timer.h	(revision 3300)
+++ code/trunk/src/orxonox/tools/Timer.h	(revision 3301)
@@ -103,11 +103,11 @@
             /** @brief Gives the Timer some extra time. @param time The amount of extra time in seconds */
             inline void addTime(float time)
-                { if (time > 0.0f) this->time_ += (long long)(time * 1000000.0f); }
+                { if (time > 0.0f) this->time_ += static_cast<long long>(time * 1000000.0f); }
             /** @brief Decreases the remaining time of the Timer. @param time The amount of time to remove */
             inline void removeTime(float time)
-                { if (time > 0.0f) this->time_ -= (long long)(time * 1000000.0f); }
+                { if (time > 0.0f) this->time_ -= static_cast<long long>(time * 1000000.0f); }
             /** @brief Sets the interval of the Timer. @param interval The interval */
             inline void setInterval(float interval)
-                { this->interval_ = (long long)(interval * 1000000.0f); }
+                { this->interval_ = static_cast<long long>(interval * 1000000.0f); }
             /** @brief Sets bLoop to a given value. @param bLoop True = loop */
             inline void setLoop(bool bLoop)