Index: orxonox/branches/updater/src/gui/orxonox_gui.cc
===================================================================
--- orxonox/branches/updater/src/gui/orxonox_gui.cc	(revision 3312)
+++ orxonox/branches/updater/src/gui/orxonox_gui.cc	(revision 3313)
@@ -120,65 +120,6 @@
   else
     {
-#ifdef HAVE_GTK2
       mainloopGUI();
-#else /* HAVE_GTK2 */
-      char boolAns = 'y';
-      char ans[10]; 
-      while(true)
-	{
-	  PRINT(0)(" Listing all the Orxonox Options: \n");
-	  PRINT(0)("  #############################\n");
-	  Window::mainWindow->walkThrough(Widget::listOptionsAndGroups, 1);
-	  
-	  PRINT(0)("\nDo you want change any of the above values now? [Yn] ");
-	  cin >>boolAns ;
-	  if (boolAns =='n' || boolAns=='N')
-	    break;
-
-	  PRINT(0)("\n Listing all groups\n");
-	  PRINT(0)("  #################\n");
-	  int groupCount = 0;
-	  Window::mainWindow->walkThrough(Widget::listGroups, &groupCount, 1);
-	  
-	  PRINT(0)("\nIn which Group? [1-%d] ", groupCount);
-	  Packer* group;
-	  while(true)
-	    {
-	      cin >> ans;
-	      int ansIp = atoi(ans);
-	      if (ansIp <= groupCount)
-		{
-		  group = static_cast<Packer*>(Window::mainWindow->findGroupByNumber(&ansIp, 1));
-		break;
-		}
-	      else
-		PRINT(0)("\nChoose a smaler Number please: [1-%d] ", groupCount);
-	    }
-	  PRINT(0)("\n\nGroup: [%s]\n\n", group->groupName);
-	  int optionCount = 0;
-	  group->walkThrough(Widget::listOptions, &optionCount, 0);
-	  PRINT(0)("\nWhich Option? [1-%d] ", optionCount);
-	  Option* option;
-	  while(true)
-	    {
-	      cin >> ans;
-	      int ansIp = atoi(ans);
-	      if (ansIp <= groupCount)
-		{
-		  option = static_cast<Option*>(group->findOptionByNumber(&ansIp, 0));
-		break;
-		}
-	      else
-		PRINT(0)("\nChoose a smaler Number please: [1-%d] ", optionCount);
-	    }
-	  PRINT(0)("\n\n:: %s ::\n", option->title);
-	  option->changeOption();
-
-	  // here follows the rest.... this will be nasty.
-	  //! \todo move this into the gui-gtk-file
-	  //! \todo finish it.
-	}
     }
 
-#endif /* HAVE_GTK2 */
 }
Index: orxonox/branches/updater/src/gui/orxonox_gui_gtk.cc
===================================================================
--- orxonox/branches/updater/src/gui/orxonox_gui_gtk.cc	(revision 3312)
+++ orxonox/branches/updater/src/gui/orxonox_gui_gtk.cc	(revision 3313)
@@ -57,5 +57,5 @@
 
 /**
-   \brief enters the GTK-main-loop
+   \brief enters the GUI's main-loop
 */
 bool mainloopGUI(void)
@@ -66,5 +66,63 @@
   gdk_threads_leave();
   delete Window::mainWindow;
-#endif /* HAVE_GTK2 */
+#else /* HAVE_GTK2 */
+  char boolAns = 'y';
+  char ans[10]; 
+  while(true)
+    {
+      PRINT(0)(" Listing all the Orxonox Options: \n");
+      PRINT(0)("  #############################\n");
+      Window::mainWindow->walkThrough(Widget::listOptionsAndGroups, 1);
+      
+      PRINT(0)("\nDo you want change any of the above values now? [Yn] ");
+      cin >>boolAns ;
+      if (boolAns =='n' || boolAns=='N')
+	break;
+      
+      PRINT(0)("\n Listing all groups\n");
+      PRINT(0)("  #################\n");
+      int groupCount = 0;
+      Window::mainWindow->walkThrough(Widget::listGroups, &groupCount, 1);
+      
+      PRINT(0)("\nIn which Group? [1-%d] ", groupCount);
+      Packer* group;
+      while(true)
+	{
+	  cin >> ans;
+	  int ansIp = atoi(ans);
+	  if (ansIp <= groupCount)
+	    {
+	      group = static_cast<Packer*>(Window::mainWindow->findGroupByNumber(&ansIp, 1));
+	      break;
+	    }
+	  else
+	    PRINT(0)("\nChoose a smaler Number please: [1-%d] ", groupCount);
+	}
+      PRINT(0)("\n\nGroup: [%s]\n\n", group->groupName);
+      int optionCount = 0;
+      group->walkThrough(Widget::listOptions, &optionCount, 0);
+      PRINT(0)("\nWhich Option? [1-%d] ", optionCount);
+      Option* option;
+      while(true)
+	{
+	  cin >> ans;
+	  int ansIp = atoi(ans);
+	  if (ansIp <= groupCount)
+	    {
+	      option = static_cast<Option*>(group->findOptionByNumber(&ansIp, 0));
+	      break;
+	    }
+	  else
+	    PRINT(0)("\nChoose a smaler Number please: [1-%d] ", optionCount);
+	}
+      PRINT(0)("\n\n:: %s ::\n", option->title);
+      option->changeOption();
+      
+      // here follows the rest.... this will be nasty.
+      //! \todo move this into the gui-gtk-file
+      //! \todo finish it.
+    }
+#endif /* HAVE_GTK2 */
+  
 }
 