Index: /orxonox/branches/updater/src/gui/orxonox_gui.cc
===================================================================
--- /orxonox/branches/updater/src/gui/orxonox_gui.cc	(revision 3317)
+++ /orxonox/branches/updater/src/gui/orxonox_gui.cc	(revision 3318)
@@ -131,4 +131,10 @@
 OrxonoxGui::~OrxonoxGui(void)
 {
-  
+  delete video;
+  delete audio;
+  delete exec;
+  delete flags;
+  delete banner;
+  delete keys;
+  delete update;
 }
Index: /orxonox/branches/updater/src/gui/orxonox_gui_audio.cc
===================================================================
--- /orxonox/branches/updater/src/gui/orxonox_gui_audio.cc	(revision 3317)
+++ /orxonox/branches/updater/src/gui/orxonox_gui_audio.cc	(revision 3318)
@@ -55,4 +55,12 @@
 }
 
+/** 
+    \brief Destructs the Audio-Stuff
+*/
+OrxonoxGuiAudio::~OrxonoxGuiAudio(void)
+{
+  // nothing to do here.
+}
+
 /**
    \brief Return the Frame
Index: /orxonox/branches/updater/src/gui/orxonox_gui_banner.cc
===================================================================
--- /orxonox/branches/updater/src/gui/orxonox_gui_banner.cc	(revision 3317)
+++ /orxonox/branches/updater/src/gui/orxonox_gui_banner.cc	(revision 3318)
@@ -67,4 +67,5 @@
 OrxonoxGuiBanner::~OrxonoxGuiBanner(void)
 {
+  // nothing to do here
 }
 
Index: /orxonox/branches/updater/src/gui/orxonox_gui_exec.cc
===================================================================
--- /orxonox/branches/updater/src/gui/orxonox_gui_exec.cc	(revision 3317)
+++ /orxonox/branches/updater/src/gui/orxonox_gui_exec.cc	(revision 3318)
@@ -70,4 +70,13 @@
 
 /**
+   \brief Destructs the Execution-stuff
+*/
+OrxonoxGuiExec::~OrxonoxGuiExec(void)
+{
+  if(this->configFile)
+    delete []this->configFile;
+}
+
+/**
    \brief Return the Frame
    \return Returns the Exec-frame
Index: /orxonox/branches/updater/src/gui/orxonox_gui_flags.cc
===================================================================
--- /orxonox/branches/updater/src/gui/orxonox_gui_flags.cc	(revision 3317)
+++ /orxonox/branches/updater/src/gui/orxonox_gui_flags.cc	(revision 3318)
@@ -41,4 +41,12 @@
 
   this->flagsFrame->fill(flagsBox);
+}
+
+/**
+   \brief Destructs the Flags-stuff
+*/
+OrxonoxGuiFlags::~OrxonoxGuiFlags(void)
+{
+  // nothing to do here
 }
 
Index: /orxonox/branches/updater/src/gui/orxonox_gui_keys.cc
===================================================================
--- /orxonox/branches/updater/src/gui/orxonox_gui_keys.cc	(revision 3317)
+++ /orxonox/branches/updater/src/gui/orxonox_gui_keys.cc	(revision 3318)
@@ -41,4 +41,12 @@
 
   this->keysFrame->fill(this->keysBox);
+}
+
+/**
+   \brief Destructs the Keys-stuff
+*/
+OrxonoxGuiKeys::~OrxonoxGuiKeys(void)
+{
+  // nothing to do here.
 }
 
Index: /orxonox/branches/updater/src/gui/orxonox_gui_update.cc
===================================================================
--- /orxonox/branches/updater/src/gui/orxonox_gui_update.cc	(revision 3317)
+++ /orxonox/branches/updater/src/gui/orxonox_gui_update.cc	(revision 3318)
@@ -34,5 +34,5 @@
 
 /**
-   \brief Creates an Audio-Frame
+   \brief Creates an Update-Frame
 */
 OrxonoxGuiUpdate::OrxonoxGuiUpdate(void)
@@ -62,4 +62,22 @@
 #endif /* HAVE_CURL */
   this->updateFrame->fill(this->updateBox);
+}
+
+/**
+   \brief Destructs the Update-stuff
+*/
+OrxonoxGuiUpdate::~OrxonoxGuiUpdate(void)
+{
+  if(this->tmpDir)
+    delete []this->tmpDir;
+  if(this->homeDir)
+    delete []homeDir;
+  if(this->installDataDir)
+    delete []this->installDataDir;
+  if(this->installSourceDir)
+    delete []this->installSourceDir;
+  if(this->userName)
+    delete []this->userName;
+
 
 }
Index: /orxonox/branches/updater/src/gui/orxonox_gui_video.cc
===================================================================
--- /orxonox/branches/updater/src/gui/orxonox_gui_video.cc	(revision 3317)
+++ /orxonox/branches/updater/src/gui/orxonox_gui_video.cc	(revision 3318)
@@ -49,4 +49,12 @@
 
 /**
+   \brief Destructs the Video-stuff
+*/
+OrxonoxGuiVideo::~OrxonoxGuiVideo(void)
+{
+  // nothing to do here.
+}
+
+/**
    \return Returns the Video-frame
 */