Index: /orxonox/branches/parenting/src/camera.cc
===================================================================
--- /orxonox/branches/parenting/src/camera.cc	(revision 3322)
+++ /orxonox/branches/parenting/src/camera.cc	(revision 3323)
@@ -178,5 +178,5 @@
 	  //world->calcCameraPos (&lookat, &desiredPlace);
 	  //FIXME: camera should be made via relative coordinates
-	  Vector* cameraOffset = new Vector (-10, 0, 5);
+	  Vector* cameraOffset = new Vector (-10, 5, 0);
 	  this->setRelCoor (cameraOffset);
 	} 
@@ -247,5 +247,5 @@
   gluLookAt(this->absCoordinate.x, this->absCoordinate.y, this->absCoordinate.z, 
 	    this->parent->getAbsCoor ().x, this->parent->getAbsCoor ().y, this->parent->getAbsCoor ().z,
-	    0.0, 0.0, 1.0);
+	    0.0, 1.0, 0.0);
   
 
Index: /orxonox/branches/parenting/src/player.cc
===================================================================
--- /orxonox/branches/parenting/src/player.cc	(revision 3322)
+++ /orxonox/branches/parenting/src/player.cc	(revision 3323)
@@ -136,5 +136,5 @@
   Vector direction (1.0, 0.0, 0.0);
   //direction = this->absDirection.apply (direction);
-  Vector orthDirection (0.0, 1.0, 0.0);
+  Vector orthDirection (0.0, 0.0, 1.0);
   //orthDirection = orthDirection.cross (direction);
 
Index: /orxonox/branches/parenting/src/world.cc
===================================================================
--- /orxonox/branches/parenting/src/world.cc	(revision 3322)
+++ /orxonox/branches/parenting/src/world.cc	(revision 3323)
@@ -272,16 +272,16 @@
 
   int sizeX = 100;
-  int sizeY = 80;
+  int sizeZ = 80;
   float length = 1000;
   float width = 200;
   float widthX = float (length /sizeX);
-  float widthY = float (width /sizeY);
-  
-  float height [sizeX][sizeY];
-  Vector normal_vectors[sizeX][sizeY];
+  float widthZ = float (width /sizeZ);
+  
+  float height [sizeX][sizeZ];
+  Vector normal_vectors[sizeX][sizeZ];
   
   
   for ( int i = 0; i<sizeX-1; i+=1)
-    for (int j = 0; j<sizeY-1;j+=1)
+    for (int j = 0; j<sizeZ-1;j+=1)
       //height[i][j] = rand()/20046 + (j-25)*(j-25)/30;
 #ifdef __WIN32__
@@ -291,20 +291,19 @@
 #endif
 
-  //Die Hügel ein wenig glätten
+  //Die Huegel ein wenig glaetten
   for (int h=1; h<2;h++)
     for (int i=1;i<sizeX-2 ;i+=1 )
-      for(int j=1;j<sizeY-2;j+=1)
+      for(int j=1;j<sizeZ-2;j+=1)
 	height[i][j]=(height[i+1][j]+height[i][j+1]+height[i-1][j]+height[i][j-1])/4;
   
   //Berechnung von normalen Vektoren
-  
   for(int i=1;i<sizeX-2;i+=1)
-    for(int j=1;j<sizeY-2 ;j+=1)
+    for(int j=1;j<sizeZ-2 ;j+=1)
       {
-	Vector v1 = Vector (widthX*(1),      widthY*(j)  ,      height[i][j]);
-	Vector v2 = Vector (widthX*(i-1),    widthY*(j)  ,      height[i-1][j]);
-	Vector v3 = Vector (widthX*(i),      widthY*(j+1),      height[i][j+1]);
-	Vector v4 = Vector (widthX*(i+1),    widthY*(j),        height[i+1][j]);
-	Vector v5 = Vector (widthX*(i),      widthY*(j-1),      height[i][j-1]);
+	Vector v1 = Vector (widthX*(1),      height[i][j],      widthZ*(j) );
+	Vector v2 = Vector (widthX*(i-1),    height[i-1][j],    widthZ*(j));
+	Vector v3 = Vector (widthX*(i),      height[i][j+1],    widthZ*(j+1));
+	Vector v4 = Vector (widthX*(i+1),    height[i+1][j],    widthZ*(j));
+	Vector v5 = Vector (widthX*(i),      height[i][j-1],    widthZ*(j-1));
 	
 	Vector c1 = v2 - v1;
@@ -319,10 +318,10 @@
   int snowheight=3;
   for ( int i = 0; i<sizeX; i+=1)
-    for (int j = 0; j<sizeY;j+=1)
+    for (int j = 0; j<sizeZ;j+=1)
       {	  
-	Vector v1 = Vector (widthX*(i),      widthY*(j)  -width/2,      height[i][j]-20 );
-	Vector v2 = Vector (widthX*(i+1),    widthY*(j)  -width/2,      height[i+1][j]-20);
-	Vector v3 = Vector (widthX*(i+1),    widthY*(j+1)-width/2,    height[i+1][j+1]-20);
-	Vector v4 = Vector (widthX*(i),      widthY*(j+1)-width/2,    height[i][j+1]-20);
+	Vector v1 = Vector (widthX*(i),      height[i][j]-20,       widthZ*(j)  -width/2);
+	Vector v2 = Vector (widthX*(i+1),    height[i+1][j]-20,     widthZ*(j)  -width/2);
+	Vector v3 = Vector (widthX*(i+1),    height[i+1][j+1]-20,   widthZ*(j+1)-width/2);
+	Vector v4 = Vector (widthX*(i),      height[i][j+1]-20,     widthZ*(j+1)-width/2);
 	float a[3];
 	if(height[i][j]<snowheight){